﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Olap;
using Infragistics.Olap.FlatData;

namespace FlatData_Test
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            List<Data> d = new List<Data>
            {
                new Data { Name = "Department 1-1", Value = 100, },
                new Data { Name = "Department 1-2", Value = 200, },
                new Data { Name = "Department 1-3", Value = 120, },
                new Data { Name = "Department 1-4", Value = 110, },
                new Data { Name = "Department 2-1", Value = 150, },
                new Data { Name = "Department 2-2", Value = 170, },
                new Data { Name = "Department 2-3", Value = 190, },
                new Data { Name = "Department 2-4", Value = 230, },
            };

            FlatDataSource data = new FlatDataSource()
            {
                ItemsSource = d,
                Cube = DataSourceBase.GenerateInitialCube("Data"),
                Rows = DataSourceBase.GenerateInitialItems("[Name].[Name]"),
                Measures = DataSourceBase.GenerateInitialItems("Value")
            };

            HierarchyDescriptor<Data> ds = new HierarchyDescriptor<Data>(p => p.Name);
            ds.AddLevel("All Items", "All Items");
            ds.AddLevel(p => p.Name.Substring(0,12), "Item");
            ds.AddLevel(p => p.Name, "Item");
            data.AddHierarchyDescriptor(ds);

            pivot1.DataSource = data;
        }
    }

    public class Data
    {
        public string Name { get; set; }
        public int Value { get; set; }
    }

}
